/*
* anonymoX client
*   for Firefox
*
* Author 	Nils Hügelmann	<nils.h@anonymox.net>
* Author 	Florian Prott	<florian.p@anonymox.net>
* Author 	Christian Otto	<chris.o@anonymox.net>
* Author 	Hanno Braun	<hanno.b@anonymox.net>
*
* www.anonymox.net
*
* License: CC BY-NC-ND 3.0, see LICENSE.TXT or http://creativecommons.org/licenses/by-nc-nd/3.0/
*
* Use at your own risk
*
* This is the released, uncommented version of the code.
*/
"use strict";


const geoLocationUi = {
	currentShareLocationDialog: undefined,

	updateShareLocationDialogIfOpen: function() {
		if (geoLocationUi.currentShareLocationDialog) {
			geoLocationUi.updateShareLocationDialog(
				geoLocationUi.currentShareLocationDialog
			);
		}
	},



	updateShareLocationDialog: function(shareLocationDialog) {
		const info = new Info("geoLocationUi.updateShareLocationDialog");

		try {
			geoLocationUi.currentShareLocationDialog = shareLocationDialog;

			const win     = Services.wm.getMostRecentWindow("navigator:browser");
			const profile = attachedData.get("profile", win);

			const box = win.document.getAnonymousElementByAttribute(
				shareLocationDialog,
				"anonid",
				"anonymox-share-location-customizations"
			);
			const checkbox = win.document.getAnonymousElementByAttribute(
				shareLocationDialog,
				"anonid",
				"anonymox-share-location-override"
			);
			const notReadyLabel = win.document.getAnonymousElementByAttribute(
				shareLocationDialog,
				"anonid",
				"anonymox-share-location-not-ready"
			);
			const noOverrideLabel = win.document.getAnonymousElementByAttribute(
				shareLocationDialog,
				"anonid",
				"anonymox-share-location-no-override"
			);

			if (!(box && checkbox && notReadyLabel && noOverrideLabel)) {




				return;
			}

			if (!state.isReady) {
				checkbox.setAttribute("checked" , false);
				checkbox.setAttribute("disabled", true );

				notReadyLabel.removeAttribute("hidden");
				noOverrideLabel.setAttribute("hidden", true);

				return;
			}
			if (!profile.gatewayFilter.enabled) {
				box.setAttribute("hidden", true);

				return;
			}
			if (profile.name === "local" || profile.name === "special") {
				checkbox.setAttribute("checked" , false);
				checkbox.setAttribute("disabled", true );

				notReadyLabel.setAttribute("hidden", true);
				noOverrideLabel.removeAttribute("hidden");

				return;
			}

			checkbox.setAttribute("checked", profile.fakeGeolocation);
			checkbox.removeAttribute("disabled");
			notReadyLabel.setAttribute("hidden", true);

			checkbox.addEventListener("command", function() {
				const fakeGeolocation = checkbox.hasAttribute("checked");
				profile.setGeolocationFaking(fakeGeolocation);
				geoLocation.updateFakeApiResponse(profile);
			});
		}
		catch (e) {
			info.error(e);
		}
	}
};
