/*
* anonymoX client
*   for Firefox
*
* Author 	Nils Hügelmann	<nils.h@anonymox.net>
* Author 	Florian Prott	<florian.p@anonymox.net>
* Author 	Christian Otto	<chris.o@anonymox.net>
* Author 	Hanno Braun	<hanno.b@anonymox.net>
*
* www.anonymox.net
*
* License: CC BY-NC-ND 3.0, see LICENSE.TXT or http://creativecommons.org/licenses/by-nc-nd/3.0/
*
* Use at your own risk
*
* This is the released, uncommented version of the code.
*/
"use strict";












function overrideProxyCredentialDialog(win) {
	let info = new Info("overrideProxyCredentialDialog");

	try {
		if (!core.gatewayListCache) {



			return;
		}

		let args = win.arguments[0].QueryInterface(Ci.nsIWritablePropertyBag2).QueryInterface(Ci.nsIWritablePropertyBag);

		if (args.getProperty("promptType") != "promptUserAndPass") return;

		let proxyMatches = args.getProperty("text").match(/moz-proxy:\/\/([^:]+):(\d+)/);

		if (!proxyMatches) return;

		let host = proxyMatches[1];
		let port = proxyMatches[2];

		let gateway;

		core.gatewayListCache.forEach(
			function(gw){
				if ( (gw.ip == host || gw.tlsHostname == host) && gw.port == port)
					gateway = gw;
			}
		);

		if (gateway){



			if ( new Date().getTime() - gateway.lastDialogAuthTime < 10 * 1000){
				if (!gateway.fastDialogAuthCount)
					gateway.fastDialogAuthCount = 0;

				gateway.fastDialogAuthCount++;

				if (gateway.fastDialogAuthCount > 10){
					info.debug("too many authDialogs for " + gateway.id + " -> abort auth");

					gateway.fastDialogAuthCount = 0;

					win.close();
					return;
				}
			}

			gateway.lastDialogAuthTime = new Date().getTime();



			info.debug("auto-filling credentials for " + gateway.id);

			win.document.getElementById("loginTextbox").value = config.user;
			win.document.getElementById("password1Textbox").value = config.pass;

			win.document.getElementById("commonDialog").acceptDialog();
		}

	} catch(e){
		info.error("load: " + e);
	}
}
